<template>
  <IndexLayout>
    <Table
      :columns="columns"
      :data="data"
      is-scrollable
    />
  </IndexLayout>
</template>

<script>
import IndexLayout from '../components/indexLayout/IndexLayout';
import Table from '../components/table/Table';
import bpMixin from '../mixins/bpMixin';

export default {
  name: 'IndexPage',
  components: { Table, IndexLayout },
  mixins: [bpMixin],
  data() {
    return {
      columnsVisibility: {
        desktop: ['rank', 'name', 'price', 'marketCap', 'vwap', 'supply', 'volume24', 'change24', 'trade'],
        tablet: ['rank', 'name', 'price', 'marketCap', 'vwap', 'trade'],
        mobile: ['rank', 'name', 'price'],
      },
    };
  },
  computed: {
    data() {
      return this.$store.getters['references/prices'].map(({
        id, name, rank, priceUsd, marketCapUsd, vwap24Hr, supply, volumeUsd24Hr, changePercent24Hr,
      }, index) => ({
        index,
        raw: {
          id,
          rank,
          name,
          price: priceUsd,
          marketCap: marketCapUsd,
          vwap: vwap24Hr,
          supply,
          volume24: volumeUsd24Hr,
          change24: changePercent24Hr,
        },
      }));
    },
    columns() {
      return [
        { key: 'rank' },
        { key: 'name' },
        { key: 'price' },
        { key: 'marketCap' },
        { key: 'vwap' },
        { key: 'supply' },
        { key: 'volume24' },
        { key: 'change24' },
        { key: 'trade' },
      ].filter(({ key }) => this.columnsVisibility[
        this.isMobile ? 'mobile' : (this.isTablet ? 'tablet' : 'desktop')
      ].indexOf(key) > -1).map((item) => ({
        ...item,
        text: this.$t(`pages.index.table.${item.key}`),
      }));
    },
  },
};
</script>
